#!/usr/bin/env python

#-----------------------------------------------------------------------
# client.py
# Author: Bob Dondero
#-----------------------------------------------------------------------

import sys
import socket
import json

#-----------------------------------------------------------------------

def write_courses(courses):

    for course in courses:
        print(course['name'])
        book = course['book']
        print(book['title'])
        print(book['price'])
        print()

#-----------------------------------------------------------------------

def main():

    if len(sys.argv) != 3:
        print('Usage: python %s host port' % sys.argv[0])
        sys.exit(1)

    try:
        host = sys.argv[1]
        port = int(sys.argv[2])

        with socket.socket() as sock:
            sock.connect((host, port))
            flo = sock.makefile(mode='r', encoding='utf-8')
            json_str = flo.readline()
            courses = json.loads(json_str)

        write_courses(courses)

    except Exception as ex:
        print(ex, file=sys.stderr)
        sys.exit(1)

#-----------------------------------------------------------------------

if __name__ == '__main__':
    main()
